/*
 * Copyright (c) 2011 The Chromium OS Authors.
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <common.h>
#include <command.h>
#include <errno.h>
#include <asm/io.h>
#include <asm/arch/ddr.h>
#include <asm/arch/clock.h>
#include <asm/arch/imx8m_ddr.h>
#include <asm/arch/lpddr4_define.h>
#include <asm/sections.h>

static int do_dfr(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
        unsigned int addr;
        unsigned int data;

        int retval = 0;

        if (argc < 1) return CMD_RET_USAGE;

	addr = simple_strtoul(argv[1], NULL, 16);

        /* enable the ddrphy apb */
        dwc_ddrphy_apb_wr(0xd0000, 0x0);
        dwc_ddrphy_apb_wr(0xc0080, 0x3);

	data = dwc_ddrphy_apb_rd(addr);

        /* disable the ddrphy apb */
        dwc_ddrphy_apb_wr(0xc0080, 0x2);
        dwc_ddrphy_apb_wr(0xd0000, 0x1);

        printf("%08x = 0x%08x\n", addr, data);

	return retval;
}

U_BOOT_CMD(dfr, CONFIG_SYS_MAXARGS, 0, do_dfr,
        "Read DFI Register",
        "address\n"
);
